--[[
Prototype Game Engine v0.02

Class where generic game engine functions are writen
-collision detection


]]

--Engine = gideros.class(Sprite)

function Sprite:checkCollision(sprite2) --accepts two sprites to compare.  Returns true if sprites collided, false otherwise
	--print("Collision check called")
	left1 = sprite1:getX()
	left2 = sprite2:getX()
	right1 = sprite1:getX()+sprite1:getWidth()
	right2 = sprite2:getX()+sprite2:getWidth()

	top1 = sprite1:getY()
	top2 = sprite2:getY()
	bottom1 = sprite1:getY() + sprite1:getHeight()
	bottom2 = sprite2:getY() + sprite2:getHeight()
	
	if (bottom1 < top2) then return false end
	
    if (top1 > bottom2) then return false end

    if (right1 < left2) then return false end
    if (left1 > right2) then return false end
	
	--The following checks where collision occurs and sets boolean variables to each sprite
	
	if bottom1 > top2 and (top1 + sprite1:getHeight()*0.6) < top2 then
		--print("collision with floor")
		sprite1.hitBottom = true
		sprite2.hitTop = true
		else
		sprite1.hitBottom = false
		sprite2.hitTop = false
		end
		
	if top1 < bottom2 and (top1 + sprite1:getHeight()*0.3) > bottom2 then
		sprite1.hitTop = true
		sprite2.hitBottom = true
		else
		sprite1.hitTop = false
		sprite2.hitBottom = false
		end
		
	if right1 > left2 and (left1 + sprite1:getWidth()*0.3) < left2 then
		sprite1.hitRight = true
		sprite2.hitLeft = true
		else
		sprite1.hitRight = false
		sprite2.hitLeft = false
		end
	-- resolve conflict when player hits wall and floor at the same time....	
	if sprite1.hitBottom == true and sprite1.hitRight == true then
		sprite1.hitBottom = false
		end
	
	--print("collision")
    return true

end

-- returns tables containing  collision points

function Sprite:getCollisionPoints()
	
	local x = self:getX()
	local y = self:getY()
	local width = self:getWidth()
	local height = self:getHeight()
	
	local table = {TL={}, TR={}, BL={}, BR={}}
	
	table.TL.x = x
	table.TL.y = y
	table.TR.x = x+width
	table.TR.y = y
	table.BR.x = x+width
	table.BR.y = y+height
	table.BL.x = x
	table.BL.y = y+height
	
	return table
	
end

--function to check player collision with blocks within map layer in X direction
--moves player to new  X position
--returns: null

