
Camera = Core.class(Sprite)


-- camera class requires a map and a player to put it in

function Camera:init(map, player)

self.mapWidth = map:getMapWidth()
print(self.mapWidth)

-- set variables that the camera will use for control

--[[self.xLeft = 
self.xRight
self.yUp
self.yDown]]

-- player values set to camera values
self.oX = player.oX
self.oY = player.oY
self.maxDis = 80


--permissions for movement
self.playerMoveLeft = true
self.playerMoveRight = true
self.playerMoveUp = true
self.playerMoveDown = true

-- boolean value that determines when camera is "moving" or not
self.cameraLocked = false

-- add event listeners
self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame)
end

function Camera:onEnterFrame(event)
	if not startGame and not pauseGame then
	--[[Camera:movePlayer()
	Camera:moveMap()]]
	
	Camera:updateRatio()
	Camera:updatePositions()
	end

end

--[[function Camera:moveMap()

	if player.xVel < 0 and player:getX() < 400 then-- if velocity is to left and player can go left
		--do nothing
		map:setX(map:getX() - player.xVel) -- move map right.
		self.playerMoveLeft = false -- if map moves, player cannot
		if map:getX() > 0 then -- unless at edge
			map:setX(0) --set map to edge
			--self.playerMoveLeft = true -- allow player to move closer to wall
			end 
	end
	
	if player.xVel > 0 and player:getX() > 400 then -- if player is moving to Right
		--print("RIGHT")
		map:setX(map:getX() - player.xVel) -- move map.
		self.playerMoveRight = false
		if map:getX() + map.width < 800 then 
			map:setX(800 - map.width) 
			--self.playerMoveRight = true --allow player to move closer to wall
			end 
	end
	
		if player.yVel < 0  and player:getY() < 240 then -- if player is moving up
		map:setY(map:getY() - player.yVel) -- move map.
		self.playerMoveUp = false
		if map:getY() > 0 then 
			map:setY(0)
			--self.playerMoveUp = true
			end 
	end
	
	if player.yVel > 0 and player:getY() > 240 then -- if player is moving down
		map:setY(map:getY() - player.yVel) -- move map.
		self.playerMoveDown = false
		if map:getY() + map.height < 480 then 
			map:setY(480 - map.height) 
			self.playerMoveDown = true
			end
	end
	
end]]

--[[function Camera:movePlayer()

	-- set permissions to move based on player position
	local x, y = player:getPosition()
	if x + player:getWidth()/2 <= 400 then self.playerMoveRight = true end --if player on left of screen, can move right
	if x + player:getWidth()/2 >= 400 then self.playerMoveLeft = true  end --if player on right of screen, can move Left
	if y + player:getHeight()/2 >= 240 then self.playerMoveUp = true end --if player on bottom of screen, can move up
	if y + player:getHeight()/2 <= 240 then self.playerMoveDown = true end --if player on top of screen, can move down
	
	if player.xVel < 0 and self.playerMoveLeft == true or
		player.xVel > 0 and self.playerMoveRight == true then
		
		player:setX(x + player.xVel)
		end
		
	if player.yVel < 0 and self.playerMoveUp == true or 
		player.yVel > 0 and self.playerMoveDown == true then
		
		player:setY(y + player.yVel)
		end
		
	-- player can never go beyond the bounerdies of the screen
	if player:getX() < 0 then player:setX(0) end
	if player:getX() + player:getWidth() > 800 then player:setX(800 - player:getWidth()) end
	if player:getY() < 0 then player:setY(0) end
	if player:getY() + player:getHeight() > 480 then player:setY(480 - player:getHeight()) end
end]]

function Camera:updateRatio()
	--finds ratio of player velocity versus max velocity
	-- when player is at max vel, only map moves

	self.xRatio = math.abs(player.xVel/player.maxVel)
	self.yRatio = math.abs(player.yAccel/player.maxVel)

end

function Camera:updatePositions()

	map:setX(map:getX() - player.xVel*self.xRatio)
	map:setY(map:getY() - player.yVel*self.yRatio)
	
	if player:getX() < 300 and self.xRatio > 0 then
		player:setX(player:getX() + 4)
		map:setX(map:getX() + 4)
		end
	
	if player:getX() > 500 and self.xRatio > 0 then
		player:setX(player:getX() - 4)
		map:setX(map:getX() - 4)
		end
		
	if player:getY() < 180 and self.xRatio > 0 then
		player:setY(player:getY() + 6)
		map:setY(map:getY() + 6)
		end
	
	if player:getY() > 300 and self.xRatio > 0 then
		player:setY(player:getY() - 6)
		map:setY(map:getY() - 6)
		end
	
	if map:getX() + map.width < 800 then 
			map:setX(800 - map.width) 
			self.xRatio = 0
			--self.playerMoveRight = true --allow player to move closer to wall
			end
	
	if map:getX() > 0 then -- unless at edge
			map:setX(0) --set map to edge
			self.xRatio = 0
			--self.playerMoveLeft = true -- allow player to move closer to wall
			end
			
	if map:getY() > 0 then 
			map:setY(0)
			self.yRatio = 0
			--self.playerMoveUp = true
			end 
			
	if map:getY() + map.height < 480 then 
			map:setY(480 - map.height)
			self.yRatio = 0
			--self.playerMoveDown = true
			end		
	
	
	player:setX(player:getX() + player.xVel*(1-self.xRatio))
	player:setY(player:getY() + player.yAccel*(1-self.yRatio))
	

	
	if player:getX() < 0 then player:setX(0) end
	if player:getX() + player:getWidth() > 800 then player:setX(800 - player:getWidth()) end
	if player:getY() < 0 then player:setY(0) end
	if player:getY() + player:getHeight() > 480 then player:setY(480 - player:getHeight()) end

end
