
Player = Core.class(Sprite)

function Player:init()

	self.gravity = 1 --was 1
	self.flighttMax = 200
	self.flight = self.flightMax
	
	self.startX = 150
	self:setX(self.startX)
	self.hold = false
	
	self.xAccel = 0
	self.yAccel = 0
	
	self.xVel = 0
	self.yVel = 0
	
	self.newY = 0
	self.newX = 0

	self.mass =-100
	
	self.maxAccel = 30
	self.maxVel = 30

	self.onGround = false
	
	filter = 0.1
	
	fx = 0
	fy = 0
	fz = 0
	
	self.Oy, self.Ox, self.Oz = accelerometer:getAcceleration() -- get oridentation at startup
	
	self:addEventListener(Event.MOUSE_DOWN, self.mouseDown, self)
	self:addEventListener("enterFrame", self.onEnterFrame, self)
	
-- Load textures and create texture package
	self.animationTexturePack = TexturePack.new("Assets/grfx/PlayerAnimations.txt", "Assets/grfx/PlayerAnimations.png")
	
-- Load animatoions and set to player.
-- init texture animation loader and read animations... 
	self.aniLoader = CTNTAnimatorLoader.new()

-- read nimation infos 
	self.aniLoader:loadAnimations("Assets/grfx/PlayerAnimation.tan", self.animationTexturePack, false)
	
-- create animation
	self.lastDirection = 1
	self.anim = CTNTAnimator.new(self.aniLoader)
	self.anim:setAnimation("REST_RIGHT")
	self.anim:playAnimation()
    self.anim:addChildAnimation(self)
-- add animation as child of player
	--self:addChild(self.anim)
end

function Player:onEnterFrame(event)
	if not pauseGame then
	-- get accelerometer values
	local y, x, z = accelerometer:getAcceleration()
	x = x - self.Ox
	y = y - self.Oy
	z = z - self.Oz
	
	-- do the low-pass filtering
	fx = x * filter + fx * (1 - filter)
	fy = y * filter + fy * (1 - filter)
	fz = z * filter + fz * (1 - filter)


	self:updateXAccel()
	self:updateVelocity(event.deltaTime)
	self:updateAnimation()
	self:updatePosition()
	
	end
end

function Player:updateXAccel() -- the more the device is tilted, the more acceleraction

		self.xAccel = fx*self.mass -- INVERTED
		if math.abs(self.xAccel) > self.maxAccel then -- we know accel is too high 
			if self.xAccel < 0 then -- it's negative therfore we set it to the lowest possible accel
				self.xAccel = self.maxAccel*-1
				end
			if self.xAccel > 0 then -- it's positive so we set it to highest possible accel
				self.xAccel = self.maxAccel
				end
		end

end



function Player:updateVelocity()
		if self.xAccel > -3 and self.xAccel < 3 then
			self.xVel = 0
			else 
			self.xVel = self.xAccel
			end
		
		if math.abs(self.xVel) > self.maxVel then
			if self.xVel < 0 then
				self.xVel = self.maxVel*-1
				end
			if self.xVel > 0 then
				self.xVel = self.maxVel
				end
		end
		
	
end

function Player:updateAnimation()

	if self.xVel < 0 then
		if self.onGround == true then
			self.anim:setAnimation("RUN_LEFT")
			self.anim:setSpeed(math.abs(self.xVel))
			self.lastDirection = 3
	
		elseif self.onGround == false then
			self.anim:setAnimation("FLY_LEFT")
			self.anim:setSpeed(math.sqrt(self.xVel*self.xVel + self.yAccel*self.yAccel))
			end
	elseif self.xVel > 0 then
		if self.onGround == true then
			self.anim:setAnimation("RUN_RIGHT")
			self.anim:setSpeed(math.abs(self.xVel))
			self.lastDirection = 4
			
		elseif self.onGround == false then
			self.anim:setAnimation("FLY_RIGHT")
			self.anim:setSpeed(math.sqrt(self.xVel*self.xVel + self.yAccel*self.yAccel))
			end
		

	else
		-- set to idle animations
		if self.lastDirection == 3 then
			self.anim:setAnimation("REST_LEFT")
		elseif self.lastDirection == 4 then
			self.anim:setAnimation("REST_RIGHT")

		end
	end
	
	
end

function Player:updatePosition()

--set coordinates from local to global
local x, y = self:getPosition()

	if(self.yAccel > -11 and hold) then  
		self.yAccel = self.yAccel - 1.1
		end
	 
  if(self.yAccel > -11 and not hold) then --falls faster
     self.yAccel = self.yAccel - 1.1
     end
	 
--Calculate the new position of the player 
	self.newY = self.gravity - self.yAccel
	self.newX = self.xVel
	--self:setY(y + self.newY)
	--print(self.newY)
end

function Player:mouseDown(event)
	hold = true
	
	 if(self.onGround == true) then
		self.yAccel = self.yAccel + 28
        end
	if self.onGround == false and self:getY() > 0  then
		self.animateFly = true 
		self.yAccel = self.yAccel + 10
		end
	--self.Oy, self.Ox, self.Oz = accelerometer:getAcceleration()

end

function Player:mouseUp(event)


end

function Player:updateFlight()


		
end


